
' CamBam VBScript - dh42 02/2015
' select drawing objects before running the script
'
'V1.0 scan the polylines in the selection and return the smallest arc radius found in each
' in the log window
'
'V1.1 add center point and radius values on the current layer, give min and max arc value for external and internal
'
'
'V1.2 dispatch the min external and internal radius to 2 separate layers
'
' change this values to change texte size and fonts, and text before and after the value

const TXT_SIZE = 4
const TXT_FONT = "1CamBam_Stick_7"
const TXT_LEAD = " R="
const TXT_END = ""

const IN_LAYER = "Arcs Internes mini"
const OUT_LAYER = "Arcs Externes mini"
const OTHER_LAYER = "Autres Arcs"

dim inlayer as Layer 
dim outlayer as Layer 
dim otherlayer as Layer

dim c1 as color = color.Yellow
dim c2 as color = color.Cyan
dim c3 as color = color.white


'---------------------------------------------------------------------------------
'
sub main


	dim ent as Entity
	dim pli as Polyline
	dim plitem as PolylineItem
	dim ct as integer
	dim nbseg as integer
	dim bulge as double
	dim xyz as point3F
	dim arc_list as New System.Collections.Generic.List(Of Arc2F)
	dim a as Arc2F
	dim min_int_radius as double = 0
	dim min_ext_radius as double = 0

	dim seg as Object = new Object

	addlayers()

	'for all selected entitites
	for each ent in view.SelectedEntities	
			
		if typeof ent is Polyline	'only if polyline
	
			pli = ent	'cast a pointer from Entity to Polyline
			
			nbseg = pli.NumSegments	'number of segments/arcs in the polyline
	
			for ct = 0 to nbseg - 1	'scan all segment in the polyline
			
				seg = pli.GetSegment(ct)	'get an Object from the current segment
				
				'test if it's an Arc
				if seg.GetType.Tostring = "CamBam.Geom.Arc2F" then
					
					a = seg	'cast a pointer from Object to Arc2F
					
					'add the arc to the list for further use.
					arc_list.add(a)

					'if direction = -1 AND Bulge is negativ, the the arc is intenal

					select case pli.Direction

					case = -1
						if a.Bulge < 0 'internal arc
	
							'test if radius of the internal arc is minus than the minus found (except for 0)
							if min_int_radius <> 0
								if a.Radius < min_int_radius then	'a smaller internal radius was found
									min_int_radius = a.Radius
								end if
							else
									min_int_radius = a.Radius	'the previous stored radius was 0
							end if
						else	'external arc
	
							'test if radius of the external arc is minus than the minus found (except for 0)
							if min_ext_radius <> 0
								if a.Radius < min_ext_radius then	'a smaller external radius was found
									min_ext_radius = a.Radius
								end if
							else
									min_ext_radius = a.Radius	'the previous stored radius was 0
							end if
						end if
					case = 1
						if a.Bulge > 0 'internal arc
	
							'test if radius of the internal arc is minus than the minus found (except for 0)
							if min_int_radius <> 0
								if a.Radius < min_int_radius then	'a smaller internal radius was found
									min_int_radius = a.Radius
								end if
							else
									min_int_radius = a.Radius	'the previous stored radius was 0
							end if
						else	'external arc
	
							'test if radius of the external arc is minus than the minus found (except for 0)
							if min_ext_radius <> 0
								if a.Radius < min_ext_radius then	'a smaller external radius was found
									min_ext_radius = a.Radius
								end if
							else
									min_ext_radius = a.Radius	'the previous stored radius was 0
							end if
						end if

					case else 'open polyline, use only one side

						if min_int_radius <> 0
							if a.Radius < min_int_radius then	'a smaller radius was found
								min_int_radius = a.Radius
							end if
						else
							min_int_radius = a.Radius	'the previous stored radius was 0
						
						end if

					end select

 					
				end if

			next ct
	
			if pli.Direction <> 0 'closed polyline
				app.log("Le rayon intérieur minimum de la polyligne n°: " & ent.id &" est de: "& format(min_int_radius ,"0.00##"))
				app.log("Le rayon extérieur minimum de la polyligne n°: " & ent.id &" est de: "& format(min_ext_radius ,"0.00##"))
				app.log("")
			else
				app.log("Le rayon minimum de la polyligne ouverte n°: " & ent.id &" est de: "& format(min_int_radius ,"0.00##"))
			end if

			' read the list to display the data for this polyline
			Read_list(arc_list,min_int_radius, min_ext_radius, pli.Direction)
	
			min_int_radius = 0
			min_ext_radius = 0			
	
			' clear the list for next polyline to process
			arc_list.Clear()
			app.log("")
	

		end if


	next ent

end sub

Sub Read_list( a as System.Collections.Generic.List(of Arc2F),ri as double, re as double,d as RotationDirection)

	dim arcdata as Arc2F
	dim center as Point3F = New Point3F
	dim radius_text as Mtext = New Mtext
	dim lp as PointList = New PointList
	dim invert as double 
	dim ismin as boolean = false	'become true if an arc is marked as min

	radius_text.Height = TXT_SIZE
	radius_text.TextAlignmentH = 0
	radius_text.TextAlignmentV = 1
	radius_text.Font = TXT_FONT

	'scan the list of arc2F
	For each arcdata in a

		'app.log("Rayon: " & arcdata.radius & "   Bulge: " & arcdata.Bulge)

		'fill a Mtext with arc radius value
		radius_text.Text = TXT_LEAD & format(arcdata.radius,"0.0###") & TXT_END

		'Mtext position
		center.x = arcdata.center.x
		center.y = arcdata.center.y

		radius_text.P1 = center	'insertion point

		if d < 0 then	'the positive/negative bulge in depending of the polyline direction
			invert = -1
		else
			invert = 1
		end if

		
		' identify the smallest arcs

		if d<>0 then	'closed polyline

			if arcdata.bulge * invert > 0 then	'internal
	
				if arcdata.radius - ri < math.abs(0.0000001) then
	
					doc.add(radius_text.clone,inlayer )	
					ismin = true

				end if
			 
			else	'external
	
				if arcdata.radius - re < math.abs(0.0000001) then
	
					doc.add(radius_text.clone,outlayer )	
					ismin = true
	
				end if
	
			end if
			
		else	'open polyline

			if arcdata.radius - ri < math.abs(0.0000001) then
	
					doc.add(radius_text.clone,inlayer )	
					ismin = true

			end if
			
	
		end if

		'add a clone of the Mtext 
		
		if ismin = false then
			doc.add(radius_text.clone,otherlayer )
		else
			ismin = false	
		end if

		'add a new point in the point list
		lp.add(center)
		
	next arcdata
	
	'add a clone of the pointlist for this polyline
	doc.add(lp.clone,otherlayer )
	
end sub

sub addlayers()

		dim in_name as string = IN_LAYER 
		dim out_name as string = OUT_LAYER 
		dim other_name as string = OTHER_LAYER 

		if CamBamUI.MainUI.ActiveView.CADFile.HasLayer(IN_LAYER ) = false then
			inlayer = CreateLayer(in_name) 
			inlayer.color = c1
		else
			SetActiveLayer(IN_LAYER)
			inlayer = ActiveLayer()	
			inlayer.color = c1
		end if

		if CamBamUI.MainUI.ActiveView.CADFile.HasLayer(OUT_LAYER ) = false then
			outlayer = CreateLayer(out_name) 
			outlayer.color = c2
		else
			SetActiveLayer(OUT_LAYER)
			outlayer = ActiveLayer()	
			outlayer.color = c2
		end if

		if CamBamUI.MainUI.ActiveView.CADFile.HasLayer(OTHER_LAYER) = false then
			otherlayer = CreateLayer(other_name) 
			otherlayer.color = c3
		else
			SetActiveLayer(OTHER_LAYER)
			otherlayer = ActiveLayer()	
			otherlayer.color = c3
		end if

end sub